Loading...
Searching...
No Matches
TLS Call Home Server Configuration
Server » Server Configuration » Call Home Server Configuration

TLS Call Home server configuration creation and deletion. More...

Collaboration diagram for TLS Call Home Server Configuration:

## Functions

int | nc_server_config_add_ch_tls_ca_cert (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *cert_name, const char *cert_path, struct lyd_node **config)
| Creates new YANG configuration data nodes for a client certificate authority (trust-anchor) certificate.
int | nc_server_config_add_ch_tls_ca_cert_truststore_ref (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *cert_bag_ref, struct lyd_node **config)
| Creates new YANG configuration data nodes for a Call Home truststore reference to a set of client certificate authority (trust-anchor) certificates.
int | nc_server_config_add_ch_tls_client_cert (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *cert_name, const char *cert_path, struct lyd_node **config)
| Creates new YANG configuration data nodes for a Call Home client's (end-entity) certificate.
int | nc_server_config_add_ch_tls_client_cert_truststore_ref (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *cert_bag_ref, struct lyd_node **config)
| Creates new YANG configuration data nodes for a Call Home truststore reference to a set of client (end-entity) certificates.
int | nc_server_config_add_ch_tls_ctn (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, uint32_t id, const char *fingerprint, NC_TLS_CTN_MAPTYPE map_type, const char *name, struct lyd_node **config)
| Creates new YANG configuration data nodes for a Call Home cert-to-name entry.
int | nc_server_config_add_ch_tls_keystore_ref (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *asym_key_ref, const char *cert_ref, struct lyd_node **config)
| Creates new YANG configuration data nodes for a keystore reference to the Call Home TLS server's certificate.
int | nc_server_config_add_ch_tls_server_cert (const struct ly_ctx *ctx, const char *client_name, const char *endpt_name, const char *privkey_path, const char *pubkey_path, const char *cert_path, struct lyd_node **config)
| Creates new YANG configuration data nodes for a Call Home server's certificate.
int | nc_server_config_del_ch_tls_ca_cert (const char *client_name, const char *endpt_name, const char *cert_name, struct lyd_node **config)
| Deletes a Call Home client certificate authority (trust-anchor) certificate from the YANG data.
int | nc_server_config_del_ch_tls_ca_cert_truststore_ref (const char *client_name, const char *endpt_name, struct lyd_node **config)
| Deletes a Call Home client certificate authority (trust-anchor) certificates truststore reference from the YANG data.
int | nc_server_config_del_ch_tls_client_cert (const char *client_name, const char *endpt_name, const char *cert_name, struct lyd_node **config)
| Deletes a Call Home client (end-entity) certificate from the YANG data.
int | nc_server_config_del_ch_tls_client_cert_truststore_ref (const char *client_name, const char *endpt_name, struct lyd_node **config)
| Deletes a Call Home client (end-entity) certificates truststore reference from the YANG data.
int | nc_server_config_del_ch_tls_ctn (const char *client_name, const char *endpt_name, uint32_t id, struct lyd_node **config)
| Deletes a Call Home cert-to-name entry from the YANG data.
int | nc_server_config_del_ch_tls_keystore_ref (const char *client_name, const char *endpt_name, struct lyd_node **config)
| Deletes a TLS server certificate keystore reference from the YANG data.
int | nc_server_config_del_ch_tls_server_cert (const char *client_name, const char *endpt_name, struct lyd_node **config)
| Deletes a Call Home server certificate from the YANG data.

## Detailed Description

TLS Call Home server configuration creation and deletion.

SSH Call Home Server Configuration

## Function Documentation

## nc_server_config_add_ch_tls_server_cert()

int nc_server_config_add_ch_tls_server_cert | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | privkey_path,
|  | const char * | pubkey_path,
|  | const char * | cert_path,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a Call Home server's certificate.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | privkey_path | Path to the server's PEM encoded private key file.
  [in] | pubkey_path | Optional path to the server's public key file. If not provided, it will be generated from the private key.
  [in] | cert_path | Path to the server's certificate file.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_server_cert()

int nc_server_config_del_ch_tls_server_cert | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home server certificate from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_keystore_ref()

int nc_server_config_add_ch_tls_keystore_ref | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | asym_key_ref,
|  | const char * | cert_ref,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a keystore reference to the Call Home TLS server's certificate.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | asym_key_ref | Name of the asymmetric key pair in the keystore to be referenced.
  [in] | cert_ref | Name of the certificate, which must belong to the given asymmetric key pair, to be referenced.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_keystore_ref()

int nc_server_config_del_ch_tls_keystore_ref | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a TLS server certificate keystore reference from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_client_cert()

int nc_server_config_add_ch_tls_client_cert | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_name,
|  | const char * | cert_path,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a Call Home client's (end-entity) certificate.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | cert_name | Arbitrary identifier of the Call Home endpoint's end-entity certificate. If an Call Home endpoint's end-entity certificate with this identifier already exists, its contents will be changed.
  [in] | cert_path | Path to the certificate file.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_client_cert()

int nc_server_config_del_ch_tls_client_cert | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home client (end-entity) certificate from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in] | cert_name | Optional identifier of a client certificate to be deleted. If NULL, all of the client certificates will be deleted.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_client_cert_truststore_ref()

int nc_server_config_add_ch_tls_client_cert_truststore_ref | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_bag_ref,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a Call Home truststore reference to a set of client (end-entity) certificates.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | cert_bag_ref | Identifier of the certificate bag in the truststore to be referenced.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_client_cert_truststore_ref()

int nc_server_config_del_ch_tls_client_cert_truststore_ref | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home client (end-entity) certificates truststore reference from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_ca_cert()

int nc_server_config_add_ch_tls_ca_cert | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_name,
|  | const char * | cert_path,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a client certificate authority (trust-anchor) certificate.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | cert_name | Arbitrary identifier of the Call Home endpoint's certificate authority certificate. If an Call Home endpoint's CA certificate with this identifier already exists, its contents will be changed.
  [in] | cert_path | Path to the certificate file.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_ca_cert()

int nc_server_config_del_ch_tls_ca_cert | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home client certificate authority (trust-anchor) certificate from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in] | cert_name | Optional identifier of a CA certificate to be deleted. If NULL, all of the CA certificates will be deleted.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_ca_cert_truststore_ref()

int nc_server_config_add_ch_tls_ca_cert_truststore_ref | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | cert_bag_ref,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a Call Home truststore reference to a set of client certificate authority (trust-anchor) certificates.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | cert_bag_ref | Identifier of the certificate bag in the truststore to be referenced.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_ca_cert_truststore_ref()

int nc_server_config_del_ch_tls_ca_cert_truststore_ref | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home client certificate authority (trust-anchor) certificates truststore reference from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_add_ch_tls_ctn()

int nc_server_config_add_ch_tls_ctn | ( | const struct ly_ctx * | ctx,
|  | const char * | client_name,
|  | const char * | endpt_name,
|  | uint32_t | id,
|  | const char * | fingerprint,
|  | NC_TLS_CTN_MAPTYPE | map_type,
|  | const char * | name,
|  | struct lyd_node ** | config
| ) |  |

Creates new YANG configuration data nodes for a Call Home cert-to-name entry.

Parameters

  [in] | ctx | libyang context.
  [in] | client_name | Arbitrary identifier of the Call Home client. If a Call Home client with this identifier already exists, its contents will be changed.
  [in] | endpt_name | Arbitrary identifier of the Call Home client's endpoint. If a Call Home client's endpoint with this identifier already exists, its contents will be changed.
  [in] | id | ID of the entry. The lower the ID, the higher the priority of the entry (it will be checked earlier).
  [in] | fingerprint | Optional fingerprint of the entry. The fingerprint should always be set, however if it is not set, it will match any certificate. Entry with no fingerprint should therefore be placed only as the last entry.
  [in] | map_type | Mapping username to the certificate option.
  [in] | name | Username for this cert-to-name entry.
  [in,out] | config | Configuration YANG data tree. If *config is NULL, it will be created. Otherwise the new YANG data will be added to the previous data and may override it.

Returns
  0 on success, non-zero otherwise.

## nc_server_config_del_ch_tls_ctn()

int nc_server_config_del_ch_tls_ctn | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | uint32_t | id,
|  | struct lyd_node ** | config
| ) |  |

Deletes a Call Home cert-to-name entry from the YANG data.

Parameters

  [in] | client_name | Identifier of an existing Call Home client.
  [in] | endpt_name | Identifier of an existing Call Home endpoint that belongs to the given client.
  [in] | id | Optional identifier of the Call Home CTN entry to be deleted. If 0, all of the CTN entries will be deleted.
  [in,out] | config | Modified configuration YANG data tree.

Returns
  0 on success, non-zero otherwise.